libzypp: zypp::url::ViewOption Struct Reference

libzypp 17.25.10

Public Member Functions | Static Public Attributes | Private Member Functions | Private Attributes | Friends | List of all members
zypp::url::ViewOption Struct Reference

Url::asString() view options. More...

`#include <UrlBase.h>`

## Public Member Functions
| ViewOption ()
| Create instance with default combination of view options. More...
ViewOption & | operator= (const ViewOption &o)
| Assign specified option combination `o` to the current object. More...
bool | has (const ViewOption &o) const
| Check if specified option `o` is set in the current object. More...

## Static Public Attributes
static const ViewOption | hotfix1050625 = 0x8000
static const ViewOption | WITH_SCHEME = 0x0001
| Option to include scheme name in the URL string. More...
static const ViewOption | WITH_USERNAME = 0x0002
| Option to include username in the URL string. More...
static const ViewOption | WITH_PASSWORD = 0x0004
| Option to include password in the URL string. More...
static const ViewOption | WITH_HOST = 0x0008
| Option to include hostname in the URL string. More...
static const ViewOption | WITH_PORT = 0x0010
| Option to include port number in the URL string. More...
static const ViewOption | WITH_PATH_NAME = 0x0020
| Option to include path name in the URL string. More...
static const ViewOption | WITH_PATH_PARAMS = 0x0040
| Option to include path parameters in the URL string. More...
static const ViewOption | WITH_QUERY_STR = 0x0080
| Option to include query string in the URL string. More...
static const ViewOption | WITH_FRAGMENT = 0x0100
| Option to include fragment string in the URL string. More...
static const ViewOption | EMPTY_AUTHORITY = 0x0200
| Explicitely include the URL authority separator "//". More...
static const ViewOption | EMPTY_PATH_NAME = 0x0400
| Explicitely include the "/" path character. More...
static const ViewOption | EMPTY_PATH_PARAMS = 0x0800
| Explicitely include the path parameters separator ";". More...
static const ViewOption | EMPTY_QUERY_STR = 0x1000
| Explicitely include the query string separator "?". More...
static const ViewOption | EMPTY_FRAGMENT = 0x2000
| Explicitely include the fragment string separator "#". More...
static const ViewOption | DEFAULTS = 0x07bb
| Default combination of view options. More...

## Private Member Functions
| ViewOption (int option)

## Private Attributes
int | opt

## Friends
ViewOption | operator+ (const ViewOption &l, const ViewOption &r)
| Adds `l` and `r` to a new option combination. More...
ViewOption | operator- (const ViewOption &l, const ViewOption &r)
| Substract `r` from `l` to a new option combination. More...

## Detailed Description

Url::asString() view options.

A instance of this class represents a bit-wise combination of view option constants.

It provides ViewOption::operator+() and ViewOption::operator-() to modify a view option combination and a ViewOption::has() method, to check if a specified option is enabled or not.

Definition at line 39 of file UrlBase.h.

## Constructor & Destructor Documentation

## ◆ ViewOption() [1/2]

zypp::url::ViewOption::ViewOption | ( |  | ) |

Create instance with default combination of view options.

Definition at line 95 of file UrlBase.cc.

## ◆ ViewOption() [2/2]

zypp::url::ViewOption::ViewOption | ( | int | option | ) |
| private

Definition at line 100 of file UrlBase.cc.

## Member Function Documentation

## ◆ operator=()

ViewOption& zypp::url::ViewOption::operator= | ( | const ViewOption & | o | ) |
| inline

Assign specified option combination `o` to the current object.

Parameters

  o | The option or option combination to make a copy of.

Returns
  A reference to this option combination.

Definition at line 216 of file UrlBase.h.

## ◆ has()

bool zypp::url::ViewOption::has | ( | const ViewOption & | o | ) | const
| inline

Check if specified option `o` is set in the current object.

Parameters

  o | A view option constant.

Returns
  True, if specified option `o` is set/enabled in the instance.

Definition at line 228 of file UrlBase.h.

## Friends And Related Function Documentation

## ◆ operator+

ViewOption operator+ | ( | const ViewOption & | l,
|  | const ViewOption & | r
| ) |  |
| friend

Adds `l` and `r` to a new option combination.

Returns
  The new option combination.

Definition at line 193 of file UrlBase.h.

## ◆ operator-

ViewOption operator- | ( | const ViewOption & | l,
|  | const ViewOption & | r
| ) |  |
| friend

Substract `r` from `l` to a new option combination.

Returns
  The new option combination.

Definition at line 204 of file UrlBase.h.

## Member Data Documentation

## ◆ WITH_SCHEME

const ViewOption zypp::url::ViewOption::WITH_SCHEME = 0x0001
| static

Option to include scheme name in the URL string.

Disabling this option causes, that the URL string contains the path, query and fragment components only, for example just "/foo/bar.txt".

This option is enabled by default.

Definition at line 51 of file UrlBase.h.

## ◆ WITH_USERNAME

const ViewOption zypp::url::ViewOption::WITH_USERNAME = 0x0002
| static

Option to include username in the URL string.

This option depends on a enabled WITH_SCHEME and WITH_HOST options and is enabled by default.

Definition at line 58 of file UrlBase.h.

## ◆ WITH_PASSWORD

const ViewOption zypp::url::ViewOption::WITH_PASSWORD = 0x0004
| static

Option to include password in the URL string.

This option depends on a enabled WITH_SCHEME, WITH_HOST and WITH_USERNAME options and is disabled by default, causing to hide the password in the URL authority.

Definition at line 67 of file UrlBase.h.

## ◆ WITH_HOST

const ViewOption zypp::url::ViewOption::WITH_HOST = 0x0008
| static

Option to include hostname in the URL string.

This option depends on a enabled WITH_SCHEME option and is enabled by default.

Definition at line 74 of file UrlBase.h.

## ◆ WITH_PORT

const ViewOption zypp::url::ViewOption::WITH_PORT = 0x0010
| static

Option to include port number in the URL string.

This option depends on a enabled WITH_SCHEME and WITH_HOST options and is enabled by default.

Definition at line 81 of file UrlBase.h.

## ◆ WITH_PATH_NAME

const ViewOption zypp::url::ViewOption::WITH_PATH_NAME = 0x0020
| static

Option to include path name in the URL string.

This option is enabled by default.

Definition at line 87 of file UrlBase.h.

## ◆ WITH_PATH_PARAMS

const ViewOption zypp::url::ViewOption::WITH_PATH_PARAMS = 0x0040
| static

Option to include path parameters in the URL string.

This option depends on a enabled WITH_PATH_NAME option and is disabled by default, causing to hide the path parameters.

Definition at line 95 of file UrlBase.h.

## ◆ WITH_QUERY_STR

const ViewOption zypp::url::ViewOption::WITH_QUERY_STR = 0x0080
| static

Option to include query string in the URL string.

This option is enabled by default.

Definition at line 101 of file UrlBase.h.

## ◆ WITH_FRAGMENT

const ViewOption zypp::url::ViewOption::WITH_FRAGMENT = 0x0100
| static

Option to include fragment string in the URL string.

This option is enabled by default.

Definition at line 107 of file UrlBase.h.

## ◆ EMPTY_AUTHORITY

const ViewOption zypp::url::ViewOption::EMPTY_AUTHORITY = 0x0200
| static

Explicitely include the URL authority separator "//".

It causes, that the URL string includes an empty URL authority, for example: "file:///foo.txt" instead of just "file:/foo.txt".

This option depends on a enabled WITH_SCHEME view option and is enabled by default.

Definition at line 121 of file UrlBase.h.

## ◆ EMPTY_PATH_NAME

const ViewOption zypp::url::ViewOption::EMPTY_PATH_NAME = 0x0400
| static

Explicitely include the "/" path character.

It causes, that a "/" is added to the Url if the path name is empty, for example:

"http://localhost/" instead of just "http://localhost".

This option depends on a enabled WITH_PATH_NAME view option and is enabled by default.

Definition at line 133 of file UrlBase.h.

## ◆ EMPTY_PATH_PARAMS

const ViewOption zypp::url::ViewOption::EMPTY_PATH_PARAMS = 0x0800
| static

Explicitely include the path parameters separator ";".

It causes, that the URL allways contains the ";" path parameters separator.

This option depends on a enabled EMPTY_PATH_NAME view option and is disabled by default.

Definition at line 143 of file UrlBase.h.

## ◆ EMPTY_QUERY_STR

const ViewOption zypp::url::ViewOption::EMPTY_QUERY_STR = 0x1000
| static

Explicitely include the query string separator "?".

It causes, that if the query string is requested using the WITH_QUERY_STR option, the URL allways contains the "?" query string separator, even if the query string is empty. This option depends on a enabled WITH_QUERY_STR view option and is disabled by default.

Definition at line 154 of file UrlBase.h.

## ◆ EMPTY_FRAGMENT

const ViewOption zypp::url::ViewOption::EMPTY_FRAGMENT = 0x2000
| static

Explicitely include the fragment string separator "#".

It causes, that if the fragment string is requested using the WITH_FRAGMENT option, the URL allways contains the "#" fragment string separator, even if the fragment string is empty. This option depends on a enabled WITH_FRAGMENT view option and is disabled by default.

Definition at line 165 of file UrlBase.h.

## ◆ DEFAULTS

const ViewOption zypp::url::ViewOption::DEFAULTS = 0x07bb
| static

Default combination of view options.

By default, following view options are enabled: WITH_SCHEME, WITH_USERNAME, WITH_HOST, WITH_PORT, WITH_PATH_NAME, WITH_QUERY_STR, WITH_FRAGMENT, EMPTY_AUTHORITY, EMPTY_PATH_NAME.

Definition at line 177 of file UrlBase.h.

## ◆ hotfix1050625

const ViewOption zypp::url::ViewOption::hotfix1050625 = 0x8000
| static

Definition at line 233 of file UrlBase.h.

## ◆ opt

int zypp::url::ViewOption::opt
| private

Definition at line 236 of file UrlBase.h.

The documentation for this struct was generated from the following files:

- zypp/url/UrlBase.h
- zypp/url/UrlBase.cc